config/routes.rb
Rails.application.routes.draw do
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  resources :books
  resources :authors
  resources :categories
  resources :publication_houses
  resources :sales
  root to: "books#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/author.rb
class Author < ApplicationRecord
  has_many :books, dependent: :destroy
  belongs_to :publication_house

  validates :name, presence: true
end

app/models/book.rb
class Book < ApplicationRecord
  belongs_to :author
  has_many :sales, dependent: :destroy
  belongs_to :publication_house
  belongs_to :category
end

app/models/category.rb
class Category < ApplicationRecord
  has_one :book, dependent: :destroy
  validates :name, presence: true
end

app/models/publication_house.rb
class PublicationHouse < ApplicationRecord
  has_many :authors, dependent: :destroy
  has_many :books,   through: :authors
end

app/models/sale.rb
class Sale < ApplicationRecord
  belongs_to :books
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/authors_controller.rb
class AuthorsController < ApplicationController
  def index
    @authors=Author.all
  end

  def new
    @author = Author.new
    @publication_houses = PublicationHouse.all
  end

  def create
    binding.pry
    @author = Author.new author_params
    if @author.save
      redirect_to authors_path
    else
      @publication_houses = PublicationHouse.all
      render :new
    end
  end

  def edit
  end

  def update
    if @author.update author_params 
      redirect_to authors_path
    else
      render :edit
    end
  end
  def show
  end

  def destroy
    if @author.destroy 
      redirect_to authors_path
    else
      flash[:error]=@book.error.full_messages.join(", ")
      render :show
    end
  end

  private

  def author_params
    params.require(:author).permit(:name, :pen_name, :phone_no, :publication_house_id)
  end

  def permitted_params
    params.permit(:id)
  end

  def find_author
    @author=Author.find permitted_params["id"]
  end

end

app/controllers/books_controller.rb
class BooksController < ApplicationController
  def index
   @books=Book.all  
  end

  def new
    @book = Book.new
    @authors = Author.all
    @categories= Category.all
  end

  def create
    binding.pry
    @book = book.new book_params
    if @book.save
      redirect_to books_path
    else
      render :new
    end
  end

  def edit
    
  end 

  def update
    if @book.update book_params 
      redirect_to books_path
    else
      flash[error]=@book.error.full_messages.join(", ")
      render :edit
    end
  end

  def show
  end

  def destroy
    if @book.destroy 
      redirect_to books_path
    else
      render :show
    end
  end

  private

  def book_params
    params.require(:book).permit(:name)
  end

  def find_book
     @book=Book.find permitted_params["id"]
  end

  def permitted_params
    params.permit(:id)
  end
  
end

app/controllers/categories_controller.rb
class CategoriesController < ApplicationController
  before_action :find_category, only: %i[show edit update destroy]
  def index
    @categories = Category.all
  end

  def new
    @category = Category.new
  end

  def create
    @category = Category.new category_params
    binding .pry
    if @category.save
      redirect_to categories_path
    else
      flash[:error]=@book.error.full_messages.join(", ")
      render :new
    end
  end

  def edit
  end

  def update
    if @category.update category_params 
      redirect_to categories_path
    else
      render :edit
    end
  end
  def show
  end

  def destroy
    if @category.destroy 
      redirect_to categories_path
    else
      render :show
    end
  end

  private

  def category_params
    params.require(:category).permit(:name)
  end

  def permitted_params
    params.permit(:id)
  end

  def find_category
    @category=Category.find permitted_params["id"]

  end

end

app/controllers/publication_houses_controller.rb
class PublicationHousesController < ApplicationController
  before_action :find_publication_house, only: %i[show edit update destroy]

  def index
    @publication_houses = PublicationHouse.all
  end

  def new
    @publication_house = PublicationHouse.new
  end

  def create
    @publication_house = PublicationHouse.new publication_house_params
    if @publication_house.save
      redirect_to publication_houses_path
    else
      render :new
    end
  end

  def edit
    find_publication_house
  end

  def update
    find_publication_house
    if @publication_house.update publication_house_params
      redirect_to publication_houses_path
    else
      render :edit
    end
  end

  def show
  end

  def destroy
    if @publication_house.destroy
      redirect_to publication_houses_path
    else
      render :show
    end
  end
  
  private

  def publication_house_params
    params.require(:publication_house).permit(:name, :reg_no, :address, :phone_no)
  end

  def permitted_params
  params.permit(:id)
  end

  def find_publication_house
    @publication_house=PublicationHouse.find permitted_params["id"]
  end
end

app/controllers/sales_controller.rb
class SalesController < ApplicationController
  def index
    @sales = Sale.all
  end

  def new
    @sale = Sale.new
  end

  def create
  end

  def edit
  end 

  def update
  end

  def show
  end

  def destroy
  end

  private

  def sale_params
  end

  def find_sale
  end

  def permitted_params
  end
  
end

app/helpers/application_helper.rb
module ApplicationHelper
  def custom_bootstrap_flash
  flash_messages = []
  flash.each do |type, message|
    type = 'success' if type == 'notice'
    type = 'error'   if type == 'alert'
    text = "<script>toastr.#{type}('#{message}');</script>"
    flash_messages << text.html_safe if message
  end
  flash_messages.join("\n").html_safe
end
end

app/helpers/author_helper.rb
module AuthorHelper
end

app/helpers/books_helper.rb
module BooksHelper
end

app/helpers/categories_helper.rb
module CategoriesHelper
end

app/helpers/publication_houses_helper.rb
module PublicationHousesHelper
end

app/helpers/sales_helper.rb
module SalesHelper
end

app/views/authors/_form.html.erb
<table>
  <%= form_with model: @author do |f| %>

   <% if @author.errors.any? %>
    <% @author.errors.full_messages.each do |message| %>
      <li><%= message %></li>
    <% end %>
  <% end %>

    <tr>
      <th><%= f.label :Name %></th>
      <td><%= f.text_field :name, value: @author.name %></td>
    </tr>

    <tr>
      <th><%= f.label :Pen_Name %></th>
      <td><%= f.text_field :pen_name, value: @author.pen_name %></td>
    </tr>

    <tr>
      <th><%= f.label :Phone_No %></th>
      <td><%= f.text_field :phone_no, value: @author.phone_no %></td>
    </tr>

    <tr>
      <td><%= f.label :publication_house_id, value: 'Publication House' %></td>
      <td> <%= f.collection_select(:publication_house_id, @publication_houses, :id, :name) %></td>
    </tr>

    <tr>
      <td><%= link_to "Cancel", sales_path %></td>
      <td><%= f.submit action.to_s.upcase %></td>
    </tr>

  <% end %>
</table>

app/views/authors/edit.html.erb
<h3> Update Author Detail</h3>
<%= render 'form', action: 'update' %>

app/views/authors/index.html.erb
<%= link_to "publication House List", publication_houses_path %><br>
<%= link_to "Author", authors_path %><br>
<%= link_to "Category", categories_path %><br>
<%= link_to "Sales", sales_path %><br>
<%= link_to "Books", books_path %><br>
<h3>Author</h3>
<%= link_to "Create New", new_author_path %>
<table class="table table-dark" border="1">
  <tr>
    <th>Name</th>
    <th>Pen Name</th>
    <th>Phone No</th>
    
  </tr>
  <% @authors.each do |author| %>
  <tr>
    
    <td><%= author.name %></td>
    <td><%= author.pen_name %></td>
    <td><%= author.phone_no %></td>
    <td><%= link_to "Edit", edit_author_path(author.id) %></td>
    <td><%= link_to "Show", author_path(author.id) %></td>
    <td><%= link_to "Delete", author_path(author.id), method: :delete, data: {confirm: "Are your sure?"} %></td>
  </tr>
  <% end %>
</table>

app/views/authors/new.html.erb
<h3> Add Author Detail</h3>
<%= render 'form', action: 'create' %>

app/views/authors/show.html.erb
<h3>Author Detail</h3>
<table class="table table-dark" border="1">
  <tr>
    <th>Name</th>
    <th>Pen Name</th>
    <th>Phone No</th>
  </tr>
  <% @authors.each do |author| %>
  <tr>
    <td><%= author.name %></td>
    <td><%= author.pen_name %></td>
    <td><%= author.phone_no %></td>
    <td><%= link_to "Edit", edit_author_path(author.id) %></td>
  </tr>
  <% end%>
</table>

app/views/books/_form.html.erb
<table class="">
  <%= form_with model: @book do |f| %>

    <tr>
      <th><%= f.label :Name %></th>
      <td><%= f.text_field :name, value: @book.name %></td>
    </tr>

    <tr>
      <th><%= f.label :Price %></th>
      <td><%= f.text_field :price, value: @book.price %></td>
    </tr>

    <tr>
      <th><%= f.label :Publication_Date %></th>
      <td><%= f.text_field :publication_date, value: @book.publication_date %></td>
    </tr>

    <tr>
      <th><%= f.label :Description %></th>
      <td><%= f.text_field :description, value: @book.description %></td>
    </tr>

     <tr>
      <td><%= f.label :author_id, value: 'Author' %></td>
      <td> <%= f.collection_select(:author_id, @authors, :id, :name) %></td>
    </tr>

    <tr>
      <td><%= f.label :category_id, value: 'category' %></td>
      <td> <%= f.collection_select(:category_id, @categories, :id, :name) %></td>
    </tr>

    <tr>
      <td><%= link_to "Cancel", sales_path, class: "btn btn-primary" %></td>
      <td><%= f.submit action.to_s.upcase %></td>
    </tr>
  <% end %>
</table>

app/views/books/edit.html.erb
<h3> Update Book Detail</h3>
<%= render 'form', action: 'Update' %>

app/views/books/index.html.erb
<%= link_to "publication House List", publication_houses_path %><br>
<%= link_to "Author", authors_path %><br>
<%= link_to "Category", categories_path %><br>
<%= link_to "Sales", sales_path %><br>
<%= link_to "Books", books_path %><br>
<h3>Books</h3>
<%= link_to "Create New", new_book_path %>
<table class="table table-dark" border="1">
  <tr>
    <th>ID</th>
    <th>Name</th>
    <th>Price</th>
    <th>Author_id</th>
    <th>Author</th>
    <th>Publication Date</th>
  </tr>
  <% @books.each do |book| %>
  <tr>
    <td><%= book.id %></td>
    <td><%= book.name %></td>
    <td><%= book.price %></td>
    <td><%= book.author_id %></td>
    <td><%= Book.last.author.name %></td>
    <td><%= book.publication_date %></td>
    <td><%= link_to "Edit", edit_book_path(book.id) %></td>
    <td><%= link_to "Show", book_path(book.id) %></td>
    <td><%= link_to "Delete", book_path(book.id), method: :delete, data: {confirm: "Are your sure?"} %></td>
  </tr>
  <% end %>
</table>

app/views/books/new.html.erb
<h3> Add Book Detail</h3>
<%= render 'form', action: 'Add' %>

app/views/books/show.html.erb
<h3>Books</h3>
<%= link_to "Create New", new_book_path %>
<table class="table table-dark" border="1">
  <tr>
    <th>ID</th>
    <th>Name</th>
    <th>Price</th>
    <th>Author_id</th>
    <th>Author</th>
    <th>Publication Date</th>
  </tr>
  <% @books.each do |book| %>
  <tr>
    <td><%= book.id %></td>
    <td><%= book.name %></td>
    <td><%= book.price %></td>
    <td><%= book.author_id %></td>
    <td><%= Book.last.author.name %></td>
    <td><%= book.publication_date %></td>
    <td><%= link_to "Edit", edit_book_path(book.id) %></td>
  </tr>
  <% end %>
</table>

app/views/categories/_form.html.erb
<%= form_with model: @category do |f| %>
<%= f.label :name %>
<%= f.text_field :name, value: @category.name %>
<%= link_to "Cancel", sales_path %>
<%= f.submit action.to_s.upcase %>
<% end %>

app/views/categories/edit.html.erb
<h3> Edit New Category</h3>
<%= render 'form', action: 'update' %>

app/views/categories/index.html.erb
<%= link_to "publication House List", publication_houses_path %><br>
<%= link_to "Author", authors_path %><br>
<%= link_to "Category", categories_path %><br>
<%= link_to "Sales", sales_path %><br>
<%= link_to "Books", books_path %><br>
<h3>Category</h3>
<%= link_to "Create New", new_category_path %>
<table>
  <tr>
    <th>Name</th>
  </tr>
  <% @categories.each do |category| %>
  <tr>
    <td><%= category.name %></td>
    <td><%= link_to "Edit", edit_category_path(category.id) %></td>
    <td><%= link_to "Show", category_path(category.id) %></td>
    <td><%= link_to "Delete", category_path(category.id), method: :delete, data: {confirm: "Are your sure?"} %></td>
  </tr>
  <% end%>
</table>

app/views/categories/new.html.erb
<h3> Create New Category</h3>
<%= render 'form', action: 'create' %>

app/views/categories/show.html.erb
<table>
  <tr>
    <th>Name</th>
  </tr>
  <tr>
    <td><%= @category.name %></td>
    <td><%= link_to "Edit", edit_category_path(@category.id) %></td>
  </tr>
</table>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Trial</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
    <%= custom_bootstrap_flash %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/publication_houses/_form.html.erb
<table>
  <%= form_with model: @publication_house do |f| %>
  <tr>
    <th><%= f.label :Name %></th>
    <td><%= f.text_field :name, value: @publication_house.name %></td>
  </tr>
  <tr>
    <th><%= f.label :Reg_No %></th>
    <td><%= f.text_field :reg_no, value: @publication_house.reg_no %></td>
  </tr>
  <tr>
    <th><%= f.label :Address %></th>
    <td><%= f.text_field :address, value: @publication_house.address %></td>
  </tr>
  <tr>
    <th><%= f.label :Phone_No %></th>
    <td><%= f.text_field :phone_no, value: @publication_house.phone_no %></td>
  </tr>
  <tr>
    <td><%= link_to "Cancel", sales_path %></td>
    <td><%= f.submit action.to_s.upcase %></td>
  </tr>
  <% end %>
</table>

app/views/publication_houses/edit.html.erb
<h3> Edit Publication House</h3>
<%= render 'form', action: 'update' %>

app/views/publication_houses/index.html.erb
<%= link_to "publication House List", publication_houses_path %><br>
<%= link_to "Author", authors_path %><br>
<%= link_to "Category", categories_path %><br>
<%= link_to "Sales", sales_path %><br>
<%= link_to "Books", books_path %><br>
<h3>Publication houses</h3>
<%= link_to "Add Publication", new_publication_house_path %>
<table>
  <tr>
    <th>Name</th>
    <th>Reg_No</th>
    <th>Address</th>
    <th>Phone_No</th>
  </tr>
  <% @publication_houses.each do |publication_house| %>
  <tr>
    <td><%= publication_house.name %></td>
    <td><%= publication_house.reg_no %></td>
    <td><%= publication_house.address %></td>
    <td><%= publication_house.phone_no %></td>
    <td> <%= link_to "Edit", edit_publication_house_path(publication_house.id) %></td>
    <td><%= link_to "Show", publication_house_path(publication_house.id) %></td>
    <td><%= link_to "Delete", publication_house_path(publication_house.id), method: :delete, data: {confirm: "Are your sure?"} %></td>
  </tr>
  <% end %>
</table>

app/views/publication_houses/new.html.erb
<h3>Add Publication </h3>
<%= render 'form', action: 'create' %>

app/views/publication_houses/show.html.erb
<h3>Publication Houses Detail</h3>
<table>
  <tr>
    <th>Name</th>
    <th>Reg_No</th>
    <th>Address</th>
    <th>Phone_No</th>
  </tr>
  <% @publication_houses.each do |publication_house| %>
  <tr>
    <td><%= publication_house.name %></td>
    <td><%= publication_house.reg_no %></td>
    <td><%= publication_house.address %></td>
    <td><%= publication_house.phone_no %></td>
    <td> <%= link_to "Edit", edit_publication_house_path(publication_house.id) %></td>
  </tr>
  <% end %>
</table>

app/views/sales/_form.html.erb
<%= form_with model: @sale do |f| %>
  <table>
    <tr>
      <th><%= f.label :Quantity %></th>
      <td><%= f.text_field :quantity, value: @sale.quantity %></td>
    </tr>
    <tr>
      <th><%= f.label :Amount %></th>
      <td><%= f.text_field :amount, value: @sale.amount %></td>
    </tr>
    <tr>
      <td><%= link_to "Cancel", sales_path %></td>
      <td align="right"><%= f.submit action.to_s.upcase %></td>
    </tr>
  </table>
<% end %>

app/views/sales/edit.html.erb
<h3> Update Sale Detail</h3>
<%= render 'form', action: 'update' %>

app/views/sales/index.html.erb
<%= link_to "publication House List", publication_houses_path %><br>
<%= link_to "Author", authors_path %><br>
<%= link_to "Category", categories_path %><br>
<%= link_to "Sales", sales_path %><br>
<%= link_to "Books", books_path %><br>
<h3>Sales</h3>
<%= link_to "Create New", new_sale_path %>
<table>
  <tr>
    <th>Quantity</th>
    <th>Amount</th>
  </tr>
  <% @sales.each do |sale| %>
  <tr>
    <td><%= sale.quantity %></td>
    <td><%= sale.amount %></td>
  </tr>
  <% end %>
</table>

app/views/sales/new.html.erb
<h3> Add Sale</h3>
<%= render 'form', action: 'create' %>